# Reflection Subscriber-1
## 1.In this tutorial, we used RwLock<> to synchronise the use of Vec of Notifications. Explain why it is necessary for this case, and explain why we do not use Mutex<> instead?
Dengan menggunakan RwLock<>, kita memastikan bahwa proses konkurensi terjadi secara aman. Kita memastikan bahwa proses read diblok hanya ketika terjadi proses write. Berbeda dengan mutex yang hanya mengizinkan 1 thread untuk mengakses data dalam satu waktu.

## 2.In this tutorial, we used lazy_static external library to define Vec and DashMap as a “static” variable. Compared to Java where we can mutate the content of a static variable via a static function, why did not Rust allow us to do so?
Rust tidak mengizinkan hal tersebut untuk mencegah data race. Untuk mengatur variabel global static secara aman, rust mendorong developer untuk menggunakan Mutex<T> atau RwLock<T> yang sering kali digabungkan dengan lazy_static!. Pendekatan ini memastikan bahwa state global tetap thread-safe ketika sedang diakses oleh seluruh program. 

# Reflection Subscriber-2
## 1. Have you explored things outside of the steps in the tutorial, for example: src/lib.rs? If not, explain why you did not do so. If yes, explain things that you have learned from those other parts of code.
Kode tersebut tampaknya adalah singleton REQWEST_CLIENT dan APP_CONFIG. Secara keseluruhan, kode ini bertujuan untuk mengatur konfigurasi projek dan membantu menghandle request HTTP.

## 2. Since you have completed the tutorial by now and have tried to test your notification system by spawning multiple instances of Receiver, explain how Observer pattern eases you to plug in more subscribers. How about spawning more than one instance of Main app, will it still be easy enough to add to the system?
Observer pattern mensimplifikasi penambahan subscribers pada notification system dengan cara `decoupling` main app dari subscribers. Ketika receiver instance dibuat, receiver tersebut dapat langsung subscribe ke main app tanpa perlu memodifikasi logika inti dari aplikasi. Sehingga membuat sistem menjadi lebih scalable dan extensible. <br>
Misal terjadi spawning lebih dari 1 instance main app, kordinasi tambahan diperlukan untuk memastikan bahwa `notification` dapat didistribusikan dengan baik pada setiap receiver. Hal ini membuat tingkat kesulitan bertambah untuk mantaining integritas sistem dan mencegah notifikasi yang duplikat.

## 3. Have you tried to make your own Tests, or enhance documentation on your Postman collection? If you have tried those features, tell us whether it is useful for your work (it can be your tutorial work or your Group Project).
Membuat test di postman dapat membantu kita untuk memastikna bahawa API dapat berjalan sesuai ekspektasi, sehingga dapat meminimalkan kesalahan sebelum deployment. Terdapat juga fitur automated tests yang dapat membantu proses debugging.